org.h2.expression

## Class Parameter

- java.lang.Object
- - org.h2.expression.Expression
  - - org.h2.expression.Parameter

All Implemented Interfaces:
  ParameterInterface

    public class Parameter
    extends Expression
    implements ParameterInterface

A parameter of a prepared statement.

### Field Summary

### Fields inherited from class org.h2.expression.Expression

`MAP_IN_AGGREGATE, MAP_IN_WINDOW, MAP_INITIAL`

### Constructor Summary

Constructors
Constructor and Description
`Parameter(int index)`

### Method Summary

Methods
`void` `checkSet()` Check if the value is set.
`int` `getCost()` Estimate the cost to process the expression.
`int` `getIndex()`
`Expression` `getNotIfPossible(Session session)` If it is possible, return the negated expression.
`Value` `getParamValue()` Get the value of the parameter if set.
`long` `getPrecision()` Get the expected precision of this parameter.
`int` `getScale()` Get the expected scale of this parameter.
`java.lang.StringBuilder` `getSQL(java.lang.StringBuilder builder)` Appends the SQL statement of this expression to the specified builder.
`TypeInfo` `getType()` Returns the data type.
`Value` `getValue(Session session)` Return the resulting value for the current row.
`int` `getValueType()` Get the expected data type of the parameter if no value is set, or the data type of the value if one is set.
`boolean` `isConstant()` Check if this expression will always return the same value.
`boolean` `isEverything(ExpressionVisitor visitor)` Check if this expression and all sub-expressions can fulfill a criteria.
`boolean` `isValueSet()` Is the value of a parameter set.
`void` `mapColumns(ColumnResolver resolver, int level, int state)` Map the columns of the resolver to expression columns.
`Expression` `optimize(Session session)` Try to optimize the expression.
`void` `setColumn(Column column)`
`void` `setEvaluatable(TableFilter tableFilter, boolean b)` Tell the expression columns whether the table filter can return values now.
`void` `setValue(Value v)`
`void` `setValue(Value v, boolean closeOld)` Set the value of the parameter.
`void` `updateAggregate(Session session, int stage)` Update an aggregate value.

### Methods inherited from class org.h2.expression.Expression

`addFilterConditions, createIndexConditions, getAlias, getBooleanValue, getColumnName, getExpressionColumns, getExpressionColumns, getExpressionColumns, getNonAliasExpression, getNullable, getSchemaName, getSQL, getSubexpression, getSubexpressionCount, getTableAlias, getTableName, getUnenclosedSQL, isAutoIncrement, isGeneratedKey, toString, writeExpressions, writeExpressions`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface org.h2.expression.ParameterInterface

`getNullable`

### Constructor Detail

#### Parameter

    public Parameter(int index)

### Method Detail

#### getSQL

    public java.lang.StringBuilder getSQL(java.lang.StringBuilder builder)

Description copied from class: `Expression`
Appends the SQL statement of this expression to the specified builder. This may not always be the original SQL statement, specially after optimization.

Specified by:
  `getSQL` in class `Expression`
Parameters:
  `builder` - string builder
Returns:
  the specified string builder

#### setValue

    public void setValue(Value v,
                boolean closeOld)

Description copied from interface: `ParameterInterface`
Set the value of the parameter.

Specified by:
  `setValue` in interface `ParameterInterface`
Parameters:
  `v` - the new value
  `closeOld` - if the old value (if one is set) should be closed

#### setValue

    public void setValue(Value v)

#### getParamValue

    public Value getParamValue()

Description copied from interface: `ParameterInterface`
Get the value of the parameter if set.

Specified by:
  `getParamValue` in interface `ParameterInterface`
Returns:
  the value or null

#### getValue

    public Value getValue(Session session)

Description copied from class: `Expression`
Return the resulting value for the current row.

Specified by:
  `getValue` in class `Expression`
Parameters:
  `session` - the session
Returns:
  the result

#### getType

    public TypeInfo getType()

Description copied from class: `Expression`
Returns the data type. The data type may not be known before the optimization phase.

Specified by:
  `getType` in class `Expression`
Returns:
  the data type

#### getValueType

    public int getValueType()

Description copied from interface: `ParameterInterface`
Get the expected data type of the parameter if no value is set, or the data type of the value if one is set.

Specified by:
  `getValueType` in interface `ParameterInterface`
Returns:
  the data type

#### mapColumns

    public void mapColumns(ColumnResolver resolver,
                  int level,
                  int state)

Description copied from class: `Expression`
Map the columns of the resolver to expression columns.

Specified by:
  `mapColumns` in class `Expression`
Parameters:
  `resolver` - the column resolver
  `level` - the subquery nesting level
  `state` - current state for nesting checks, initial value is `Expression.MAP_INITIAL`

#### checkSet

    public void checkSet()

Description copied from interface: `ParameterInterface`
Check if the value is set.

Specified by:
  `checkSet` in interface `ParameterInterface`

#### optimize

    public Expression optimize(Session session)

Description copied from class: `Expression`
Try to optimize the expression.

Specified by:
  `optimize` in class `Expression`
Parameters:
  `session` - the session
Returns:
  the optimized expression

#### isConstant

    public boolean isConstant()

Description copied from class: `Expression`
Check if this expression will always return the same value.

Overrides:
  `isConstant` in class `Expression`
Returns:
  if the expression is constant

#### isValueSet

    public boolean isValueSet()

Description copied from class: `Expression`
Is the value of a parameter set.

Specified by:
  `isValueSet` in interface `ParameterInterface`
Overrides:
  `isValueSet` in class `Expression`
Returns:
  true if set

#### setEvaluatable

    public void setEvaluatable(TableFilter tableFilter,
                      boolean b)

Description copied from class: `Expression`
Tell the expression columns whether the table filter can return values now. This is used when optimizing the query.

Specified by:
  `setEvaluatable` in class `Expression`
Parameters:
  `tableFilter` - the table filter
  `b` - true if the table filter can return value

#### getScale

    public int getScale()

Description copied from interface: `ParameterInterface`
Get the expected scale of this parameter.

Specified by:
  `getScale` in interface `ParameterInterface`
Returns:
  the expected scale

#### getPrecision

    public long getPrecision()

Description copied from interface: `ParameterInterface`
Get the expected precision of this parameter.

Specified by:
  `getPrecision` in interface `ParameterInterface`
Returns:
  the expected precision

#### updateAggregate

    public void updateAggregate(Session session,
                       int stage)

Description copied from class: `Expression`
Update an aggregate value. This method is called at statement execution time. It is usually called once for each row, but if the expression is used multiple times (for example in the column list, and as part of the HAVING expression) it is called multiple times - the row counter needs to be used to make sure the internal state is only updated once.

Specified by:
  `updateAggregate` in class `Expression`
Parameters:
  `session` - the session
  `stage` - select stage

#### isEverything

    public boolean isEverything(ExpressionVisitor visitor)

Description copied from class: `Expression`
Check if this expression and all sub-expressions can fulfill a criteria. If any part returns false, the result is false.

Specified by:
  `isEverything` in class `Expression`
Parameters:
  `visitor` - the visitor
Returns:
  if the criteria can be fulfilled

#### getCost

    public int getCost()

Description copied from class: `Expression`
Estimate the cost to process the expression. Used when optimizing the query, to calculate the query plan with the lowest estimated cost.

Specified by:
  `getCost` in class `Expression`
Returns:
  the estimated cost

#### getNotIfPossible

    public Expression getNotIfPossible(Session session)

Description copied from class: `Expression`
If it is possible, return the negated expression. This is used to optimize NOT expressions: NOT ID>10 can be converted to ID<=10. Returns null if negating is not possible.

Overrides:
  `getNotIfPossible` in class `Expression`
Parameters:
  `session` - the session
Returns:
  the negated expression, or null

#### setColumn

    public void setColumn(Column column)

#### getIndex

    public int getIndex()